withdrawals.controllers.module('details-modal',
	[`${gx.source}/libs/info_messages`],
	() => {
		return {
			vue: true,
			name: 'gx-details-modal',
			template: '#details-modal',
			parent: 'gx-withdrawals-overview',
			data: () => ({
				lang: {
					title: jse.core.lang.translate('details_modal_title', 'withdrawals'),
					close: jse.core.lang.translate('details_modal_close', 'withdrawals'),
					updateOrderId: jse.core.lang.translate('details_modal_update_order_id', 'withdrawals'),
					labels: {
						"customerDetails": jse.core.lang.translate('details_modal_label_customer_details', 'withdrawals'),
						"orderDetails": jse.core.lang.translate('details_modal_label_order_details', 'withdrawals'),
						"withdrawal": jse.core.lang.translate('details_modal_label_withdrawal', 'withdrawals'),
						"address": jse.core.lang.translate('details_modal_label_address', 'withdrawals'),
						"email": jse.core.lang.translate('details_modal_label_email', 'withdrawals'),
						"orderDate": jse.core.lang.translate('details_modal_label_order_date', 'withdrawals'),
						"deliveryDate": jse.core.lang.translate('details_modal_label_order_delivery_date', 'withdrawals'),
						"withdrawalDate": jse.core.lang.translate('details_modal_label_withdrawal_date', 'withdrawals'),
						"createdOn": jse.core.lang.translate('details_modal_label_withdrawal_created_on', 'withdrawals'),
						"createdByAdmin": jse.core.lang.translate('details_modal_label_withdrawal_created_by_admin', 'withdrawals'),
						"createdByCustomer": jse.core.lang.translate('details_modal_label_withdrawal_created_by_customer', 'withdrawals'),
						"orderId": jse.core.lang.translate('details_modal_label_withdrawal_order_id', 'withdrawals'),
					},
					male: jse.core.lang.translate('details_modal_label_male_customer', 'withdrawals'),
					female: jse.core.lang.translate('details_modal_label_female_customer', 'withdrawals'),
					confirm: jse.core.lang.translate('save', 'buttons'),
				},
				withdrawal: undefined,
				orderId: 0,
				orderIdOk: true,
			}),
			props: {
				withdrawalId: {
					type: Number
				}
			},
			watch: {
				withdrawalId(newVal) {
					if (newVal !== undefined) {
						const vm = this;
						jse.libs.xhr.post({
							url: './admin.php?do=Withdrawals/GetWithdrawal',
							data: {id: this.withdrawalId}
						}).done(response => {
							vm.withdrawal = response.withdrawal;
							vm.orderId = response.withdrawal.order.id;
							$('.details-modal.modal').modal('show');
						}).fail((response) => {
							console.error('Could not load withdrawal details.', response);
							jse.libs.info_messages.addError(jse.core.lang.translate('error_could_not_load_withdrawal_details', 'withdrawals'));
						});
					}
				}
			},
			methods: {
				checkOrderId() {
					if (this.orderId === '') {
						this.orderIdOk = true;
						return;
					}
					this.orderIdOk = Number.isInteger(parseInt(this.orderId)) && parseInt(this.orderId) > 0;
					this.orderId = isNaN(parseInt(this.orderId)) ? '' : parseInt(this.orderId);
				},
				confirm() {
					if (this.orderId !== '' && this.orderIdOk && this.orderId !== this.withdrawal.order.id) {
						jse.libs.xhr.post({
							url: './admin.php?do=Withdrawals/ChangeOrderId',
							data: {id: this.withdrawalId, orderId: parseInt(this.orderId)}
						}).done(response => {
							this.$emit('reload-overview');
						}).fail((response) => {
							console.error('Could not update order ID.', response);
							jse.libs.info_messages.addError(jse.core.lang.translate('error_could_not_update_order_id', 'withdrawals'));
						});
					}
					$('.details-modal.modal').modal('hide');
				},
			},
			init: done => done()
		}
	});