<?php
/* --------------------------------------------------------------
   dependent.inc.php 2019-02-19
   Gambio GmbH
   http://www.gambio.de
   Copyright © 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

// Include the new parameter into the content manager entry.

$sql = '
    SELECT *
    FROM `content_manager`
    WHERE `content_group` = "3889891"
';

$result = $this->query($sql, true);

if ($result->num_rows > 0) {
    while ($row = $result->fetch_assoc()) {
        if (strpos($row['content_text'], '{$klarna_hub_terms_and_conditions}') === false) {
            $value = $row['content_text'] . '<br /><br />{$klarna_hub_terms_and_conditions}<br />';

            $sql = '
                UPDATE `content_manager`
				SET `content_text` = "' . $this->coo_mysqli->real_escape_string($value) . '"
				WHERE `content_group` = "3889891" AND `languages_id` = "' . $row['languages_id'] . '"
            ';

            $t_success &= $this->query($sql, true);
        }
    }
}

// Convert base64 values of terms and conditions to the JSON string.

$sql = '
    SELECT *
    FROM `gx_configurations`
    WHERE `key` = "gm_configuration/GAMBIO_HUB_KLARNA_HUB_TERMS_AND_CONDITIONS"
';

$result = $this->query($sql, true);

if ($result->num_rows > 0) {
    $row = $result->fetch_assoc();

    if (strpos($row['value'], 'base64:') === 0) {
        $value = base64_decode(str_replace('base64:', '', $row['gm_value']));

        $sql = '
            UPDATE `gx_configurations`
            SET `value` = "' . $this->coo_mysqli->real_escape_string($value) . '"
            WHERE `key` = "gm_configuration/GAMBIO_HUB_KLARNA_HUB_TERMS_AND_CONDITIONS"
        ';

        $t_success &= $this->query($sql, true);
    }
}

// Ensure that disconnected Hub clients have a "False" configuration status, in order to avoid unnecessary
// requests towards Hub.

$sql = '
    SELECT *
    FROM `gx_configurations`
    WHERE `key` = "configuration/MODULE_PAYMENT_GAMBIO_HUB_STATUS"
        AND `value` = "True"
';

$result_status = $this->query($sql, true);

$sql = '
    SELECT *
    FROM `gx_configurations`
    WHERE `key` = "gm_configuration/GAMBIO_HUB_CLIENT_KEY"
        AND `value` = ""
';

$result_client_key = $this->query($sql, true);

if ($result_status->num_rows > 0 && $result_client_key->num_rows > 0) {
    $sql = '
        UPDATE `gx_configurations` SET
            `value` = "False"
        WHERE
            `key` = "configuration/MODULE_PAYMENT_GAMBIO_HUB_STATUS"
    ';

    $t_success &= $this->query($sql, true);
}

if (method_exists($this, 'getAdminAccessGroupIdByIdentifier')) {
    $adminAccessGroupId = $this->getAdminAccessGroupIdByIdentifier('CONTROLLER', 'HubConfiguration');
    $this->addAdminAccessGroupItem($adminAccessGroupId, 'CONTROLLER', 'GambioHub');
    $this->addAdminAccessGroupItem($adminAccessGroupId, 'CONTROLLER', 'KlarnaHub');
    $this->addAdminAccessGroupItem($adminAccessGroupId, 'CONTROLLER', 'PaymentMatchingHub');
    $this->addAdminAccessGroupItem($adminAccessGroupId, 'CONTROLLER', 'KlarnaHubSettlements');
}

$sql = '
    SELECT * FROM
    `gx_configurations`
    WHERE `key` = "configuration/MODULE_PAYMENT_GAMBIO_HUB_IP_WHITELIST"
';

$result = $this->query($sql, true);

if ($result->num_rows < 1) {
    $sql = '
        INSERT INTO `gx_configurations` (
            `key`,
            `language_id`,
            `value`,
            `default`,
            `type`,
            `sort_order`,
            `legacy_group_id`,
            `last_modified`
        ) VALUES (
            "configuration/MODULE_PAYMENT_GAMBIO_HUB_IP_WHITELIST",
            null,
            "",
            "",
            null,
            0,
            6,
            NOW()
         )
    ';

    $t_success &= $this->query($sql, true);
}

$sql = '
    SELECT *
    FROM `gx_configurations`
    WHERE `key` = "configuration/MODULE_PAYMENT_GAMBIO_HUB_DATA_OBSERVER"
';

$result = $this->query($sql, true);

if ($result->num_rows < 1) {
    $sql = '
        INSERT INTO `gx_configurations` (
            `key`,
            `language_id`,
            `value`,
            `default`,
            `type`,
            `sort_order`,
            `legacy_group_id`,
            `last_modified`
        ) VALUES (
            "configuration/MODULE_PAYMENT_GAMBIO_HUB_DATA_OBSERVER",
            null,
            "True",
            "True",
            null,
            0,
            6,
            NOW()
         )
    ';

    $t_success &= $this->query($sql, true);
}

// Remove the old data observer triggers, if they are still registered.

$sql = '
    SHOW TRIGGERS LIKE "orders"
';

$result = $this->query($sql, true);

if ($result->num_rows > 0) {
    while ($row = $result->fetch_assoc()) {
        if (isset($row['Trigger']) && $row['Trigger'] === 'hub_data_changes_orders_before_update') {
            $sql = '
                DROP TRIGGER IF EXISTS `hub_data_changes_orders_before_update`
            ';

            $t_success &= $this->query($sql, true);
        }

        if (isset($row['Trigger']) && $row['Trigger'] === 'hub_data_changes_orders_after_update') {
            $sql = '
                DROP TRIGGER IF EXISTS `hub_data_changes_orders_after_update`
            ';

            $t_success &= $this->query($sql, true);
        }

        if (isset($row['Trigger']) && $row['Trigger'] === 'hub_data_changes_orders_before_delete') {
            $sql = '
                DROP TRIGGER IF EXISTS `hub_data_changes_orders_before_delete`
            ';

            $t_success &= $this->query($sql, true);
        }
    }
}

// Add the new transactions column to the orders table.

$sql = '
    DESCRIBE `orders` "gambio_hub_transaction_mode"
';

$result = $this->query($sql, true);

if ($result->num_rows < 1) {
    $sql = '
        ALTER TABLE `orders`
        ADD COLUMN `gambio_hub_transaction_mode` VARCHAR(64) NOT NULL DEFAULT "live"
            AFTER `gambio_hub_transaction_code`
    ';

    $t_success &= $this->query($sql, true);
}
